Index: c/src/ada-tests/tmtests/tm23/tmtest.adb
===================================================================
--- c/src/ada-tests/tmtests/tm23/tmtest.adb	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
+++ c/src/ada-tests/tmtests/tm23/tmtest.adb	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
@@ -0,0 +1,399 @@
+--
+--  TMTEST / BODY
+--
+--  DESCRIPTION:
+--
+--  This package is the implementation of Test 23 of the RTEMS
+--  Timing Test Suite.
+--
+--  DEPENDENCIES: 
+--
+--  
+--
+--  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  On-Line Applications Research Corporation (OAR).
+--  All rights assigned to U.S. Government, 1994.
+--
+--  This material may be reproduced by or for the U.S. Government pursuant
+--  to the copyright license under the clause at DFARS 252.227-7013.  This
+--  notice must appear in all copies of this file and its derivatives.
+--
+--  tmtest.adb,v 1.3 1995/07/12 19:44:14 joel Exp
+--
+
+with INTERFACES; use INTERFACES;
+with RTEMS;
+with RTEMS_CALLING_OVERHEAD;
+with TEST_SUPPORT;
+with TEXT_IO;
+with TIME_TEST_SUPPORT;
+with UNSIGNED32_IO;
+
+package body TMTEST is
+
+--PAGE
+-- 
+--  INIT
+--
+
+   procedure INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      OVERHEAD      : RTEMS.UNSIGNED32;
+      TASK_PRIORITY : RTEMS.TASK_PRIORITY;
+      INDEX         : RTEMS.UNSIGNED32;
+      ID            : RTEMS.ID;
+      TASK_ENTRY    : RTEMS.TASK_ENTRY_POINT;
+      STATUS        : RTEMS.STATUS_CODES;
+   begin
+
+      TEXT_IO.NEW_LINE( 2 );
+      TEXT_IO.PUT_LINE( "*** TIME TEST 23 ***" );
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            TIMER_DRIVER.EMPTY_FUNCTION;
+         end loop;
+      OVERHEAD := TIMER_DRIVER.READ_TIMER;
+
+      TASK_PRIORITY := 5;
+
+      for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+      loop
+
+         RTEMS.TASK_CREATE( 
+            RTEMS.BUILD_NAME( 'T', 'I', 'M', 'E' ),
+            TASK_PRIORITY, 
+            1024, 
+            RTEMS.DEFAULT_MODES,
+            RTEMS.DEFAULT_ATTRIBUTES,
+            ID,
+            STATUS
+         );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_CREATE LOOP" );
+
+         if INDEX = 1 then
+            TASK_ENTRY := TMTEST.HIGH_TASK'ACCESS;
+         elsif INDEX = TIME_TEST_SUPPORT.OPERATION_COUNT then
+            TASK_ENTRY := TMTEST.LOW_TASK'ACCESS;
+         else
+            TASK_ENTRY := TMTEST.MIDDLE_TASKS'ACCESS;
+         end if;
+
+         RTEMS.TASK_START( ID, TASK_ENTRY, 0, STATUS );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_START LOOP" );
+
+         TASK_PRIORITY := TASK_PRIORITY + 1;
+
+      end loop;
+
+      RTEMS.TASK_DELETE( RTEMS.SELF, STATUS );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_DELETE OF SELF" );
+
+   end INIT;
+
+--PAGE
+-- 
+--  NULL_DELAY
+--
+
+   procedure NULL_DELAY (
+      IGNORED_ID      : in     RTEMS.ID;
+      IGNORED_ADDRESS : in     RTEMS.ADDRESS
+   ) is
+   begin
+
+      NULL;
+
+   end NULL_DELAY;
+
+--PAGE
+-- 
+--  HIGH_TASK
+--
+
+   procedure HIGH_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      INDEX    : RTEMS.TASK_PRIORITY;
+      OVERHEAD : RTEMS.UNSIGNED32;
+      STATUS   : RTEMS.STATUS_CODES;
+   begin
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            TIMER_DRIVER.EMPTY_FUNCTION;
+         end loop;
+      OVERHEAD := TIMER_DRIVER.READ_TIMER;
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            RTEMS.TIMER_CREATE(
+               INDEX,
+               TMTEST.TIMER_ID( INDEX ),
+               STATUS
+            );
+         end loop;
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TIMER_CREATE",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TIMER_CREATE
+      );
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            RTEMS.TIMER_FIRE_AFTER(
+               TMTEST.TIMER_ID( INDEX ),
+               500,
+               TMTEST.NULL_DELAY'ACCESS,
+               RTEMS.NULL_ADDRESS,
+               STATUS
+            );
+         end loop;
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TIMER_FIRE_AFTER (inactive)",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TIMER_FIRE_AFTER
+      );
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            RTEMS.TIMER_FIRE_AFTER(
+               TMTEST.TIMER_ID( INDEX ),
+               500,
+               TMTEST.NULL_DELAY'ACCESS,
+               RTEMS.NULL_ADDRESS,
+               STATUS
+            );
+         end loop;
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TIMER_FIRE_AFTER (active)",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TIMER_FIRE_AFTER
+      );
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            RTEMS.TIMER_CANCEL( TMTEST.TIMER_ID( INDEX ), STATUS );
+         end loop;
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TIMER_CANCEL (active)",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TIMER_CANCEL
+      );
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            RTEMS.TIMER_CANCEL( TMTEST.TIMER_ID( INDEX ), STATUS );
+         end loop;
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TIMER_CANCEL (inactive)",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TIMER_CANCEL
+      );
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            RTEMS.TIMER_RESET( TMTEST.TIMER_ID( INDEX ), STATUS );
+         end loop;
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TIMER_RESET (inactive)",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TIMER_RESET
+      );
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            RTEMS.TIMER_RESET( TMTEST.TIMER_ID( INDEX ), STATUS );
+         end loop;
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TIMER_RESET (active)",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TIMER_RESET
+      );
+
+      for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+      loop
+         RTEMS.TIMER_CANCEL( TMTEST.TIMER_ID( INDEX ), STATUS );
+      end loop;
+
+      TMTEST.TIME_OF_DAY := ( 1988, 12, 31, 9, 0, 0, 0 );
+
+      RTEMS.CLOCK_SET( TMTEST.TIME_OF_DAY, STATUS );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "CLOCK_SET" );
+
+      TMTEST.TIME_OF_DAY.YEAR := 1989;
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            RTEMS.TIMER_FIRE_WHEN(
+               TMTEST.TIMER_ID( INDEX ),
+               TMTEST.TIME_OF_DAY,
+               TMTEST.NULL_DELAY'ACCESS,
+               RTEMS.NULL_ADDRESS,
+               STATUS
+            );
+         end loop;
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TIMER_FIRE_WHEN (inactive)",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TIMER_FIRE_WHEN
+      );
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            RTEMS.TIMER_FIRE_WHEN(
+               TMTEST.TIMER_ID( INDEX ),
+               TMTEST.TIME_OF_DAY,
+               TMTEST.NULL_DELAY'ACCESS,
+               RTEMS.NULL_ADDRESS,
+               STATUS
+            );
+         end loop;
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TIMER_FIRE_WHEN (active)",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TIMER_FIRE_WHEN
+      );
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            RTEMS.TIMER_DELETE( TMTEST.TIMER_ID( INDEX ), STATUS );
+         end loop;
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TIMER_DELETE (active)",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TIMER_DELETE
+      );
+
+      for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+      loop
+         RTEMS.TIMER_CREATE( INDEX, TMTEST.TIMER_ID( INDEX ), STATUS );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TIMER_CREATE" );
+
+         RTEMS.TIMER_FIRE_AFTER( 
+            TMTEST.TIMER_ID( INDEX ), 
+            500,
+            TMTEST.NULL_DELAY'ACCESS,
+            RTEMS.NULL_ADDRESS,
+            STATUS 
+         );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TIMER_FIRE_AFTER" );
+
+         RTEMS.TIMER_CANCEL( TMTEST.TIMER_ID( INDEX ), STATUS );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TIMER_CANCEL" );
+
+      end loop;
+
+      TIMER_DRIVER.INITIALIZE;
+         for INDEX in 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+         loop
+            RTEMS.TIMER_DELETE( TMTEST.TIMER_ID( INDEX ), STATUS );
+         end loop;
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TIMER_DELETE (inactive)",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TIMER_DELETE
+      );
+
+      TIMER_DRIVER.INITIALIZE;
+         RTEMS.TASK_WAKE_WHEN( TMTEST.TIME_OF_DAY, STATUS );
+
+   end HIGH_TASK;
+
+--PAGE
+-- 
+--  MIDDLE_TASKS
+--
+
+   procedure MIDDLE_TASKS (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS : RTEMS.STATUS_CODES;
+   begin
+
+      RTEMS.TASK_WAKE_WHEN( TMTEST.TIME_OF_DAY, STATUS );
+
+   end MIDDLE_TASKS;
+
+--PAGE
+-- 
+--  LOW_TASK
+--
+
+   procedure LOW_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+   begin
+
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TASK_WAKE_WHEN",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TASK_WAKE_WHEN
+      );
+
+      RTEMS.SHUTDOWN_EXECUTIVE( 0 );
+
+   end LOW_TASK;
+
+end TMTEST;
Index: c/src/ada-tests/tmtests/tm23/tmtest.ads
===================================================================
--- c/src/ada-tests/tmtests/tm23/tmtest.ads	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
+++ c/src/ada-tests/tmtests/tm23/tmtest.ads	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
@@ -0,0 +1,168 @@
+--
+--  TMTEST / SPECIFICATION
+--
+--  DESCRIPTION:
+--
+--  This package is the specification for Test 23 of the RTEMS
+--  Timing Test Suite.
+--
+--  DEPENDENCIES: 
+--
+--  
+--
+--  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  On-Line Applications Research Corporation (OAR).
+--  All rights assigned to U.S. Government, 1994.
+--
+--  This material may be reproduced by or for the U.S. Government pursuant
+--  to the copyright license under the clause at DFARS 252.227-7013.  This
+--  notice must appear in all copies of this file and its derivatives.
+--
+--  tmtest.ads,v 1.3 1995/07/12 19:44:15 joel Exp
+--
+
+with TIMER_DRIVER;
+with TIME_TEST_SUPPORT;
+with RTEMS;
+
+package TMTEST is
+
+--
+--  This array contains the IDs of all RTEMS timers created by this test.
+--
+
+   TIMER_ID   : array ( RTEMS.UNSIGNED32 
+      range 1 .. TIME_TEST_SUPPORT.OPERATION_COUNT ) of RTEMS.ID;
+
+--
+--  This data item contains a time of day used by all of the
+--  "WHEN" directives timed in this test.
+--
+
+   TIME_OF_DAY      : RTEMS.TIME_OF_DAY;
+
+--
+--  The following variable is set to the execution time returned
+--  by the timer.
+--
+
+   END_TIME  : RTEMS.UNSIGNED32;
+
+--
+--  INIT
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task initializes the application.
+--
+
+   procedure INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  NULL_DELAY
+--
+--  DESCRIPTION:
+--
+--  This subprogram is a timer service routine.  It performs
+--  no actions.
+--
+
+   procedure NULL_DELAY (
+      IGNORED_ID      : in     RTEMS.ID;  
+      IGNORED_ADDRESS : in     RTEMS.ADDRESS 
+   );
+
+--
+--  HIGH_TASK
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task is responsible for measuring and reporting
+--  the following directive execution times:
+--
+--    + TIMER_CREATE
+--    + TIMER_FIRE_AFTER with an inactive timer
+--    + TIMER_FIRE_AFTER with an active timer
+--    + TIMER_CANCEL of an active timer
+--    + TIMER_CANCEL of an inactive timer
+--    + TIMER_RESET of an active timer
+--    + TIMER_RESET of an inactive timer
+--    + TIMER_FIRE_WHEN of an inactive timer
+--    + TIMER_FIRE_WHEN of an active timer
+--    + TIMER_DELETE of an active timer
+--    + TIMER_DELETE of an inactive timer
+--
+--  After measuring and reporting the above times, this task starts
+--  the timer and executes the TASK_WAKE_WHEN directive.
+--
+
+   procedure HIGH_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  MIDDLE_TASKS
+--
+--  DESCRIPTION:
+--
+--  These RTEMS tasks executes the TASK_WAKE_WHEN directive.
+--
+
+   procedure MIDDLE_TASKS (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  MIDDLE_TASKS
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task stops the timer and reports the execution time for
+--  the TASK_WAKE_WHEN directive.
+--
+
+   procedure LOW_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  This is the Initialization Tasks Table for this test.
+--
+
+   INITIALIZATION_TASKS : aliased RTEMS.INITIALIZATION_TASKS_TABLE( 1 .. 1 ) := 
+   (1=>
+     (
+       RTEMS.BUILD_NAME( 'U', 'I', '1', ' ' ),        -- task name
+       2048,                                          -- stack size
+       1,                                             -- priority
+       RTEMS.DEFAULT_ATTRIBUTES,                      -- attributes
+       TMTEST.INIT'ACCESS,                            -- entry point
+       RTEMS.NO_PREEMPT,                              -- initial mode
+       0                                              -- argument list
+     )
+   );
+
+--
+--  This is the Configuration Table for this test.
+--
+
+   CONFIGURATION : aliased RTEMS.CONFIGURATION_TABLE := (
+      RTEMS.NULL_ADDRESS,        -- will be replaced by BSP
+      256 * 1024,                -- executive RAM size
+      111,                       -- maximum # tasks
+      110,                       -- maximum # timers
+      0,                         -- maximum # semaphores
+      0,                         -- maximum # message queues
+      0,                         -- maximum # messages
+      0,                         -- maximum # partitions
+      0,                         -- maximum # regions
+      0,                         -- maximum # dp memory areas
+      0,                         -- maximum # periods
+      0,                         -- maximum # user extensions
+      RTEMS.MILLISECONDS_TO_MICROSECONDS(10), -- # us in a tick
+      0                          -- # ticks in a timeslice
+  );
+
+end TMTEST;
